---
title: "Du calcul haute performance à l'hôpital ?"
author: "Jean Feydy"
institute: ""
topic: ""
theme: "metropolis"
colortheme:
fonttheme:
fontsize: 11pt
linkcolor: black
urlcolor: blue
linkstyle: bold
aspectratio: 169
titlegraphic: 
logo:
date:
section-titles: false
toc: false
---

## PariSanté Campus : qu'y fait-on au juste ?


`\vspace*{.5cm}`{=latex}

::: columns
:::: {.column width=40%}
`\begin{center}`{=latex}
![](images/Inria_PSC.png){height=4.5cm}

`\end{center}`{=latex}
::::
:::: {.column width=60%}
`\begin{center}`{=latex}
![](images/PariSanteCampus.jpg){height=4.5cm}

`\end{center}`{=latex}
::::
:::




## L'exposé d'aujourd'hui

 \
**1.** Contexte **technologique** : la révolution des $\BR{cartes graphiques}$.

 \
**2.** Contexte **humain** : un point triple $\BR{Info + Stats + Médecine}$.

 \
**3.** Retour d'**expérience** : un an de travail en $\BR{pharmaco-vigilance}$.


# Contexte technologique


## Vers une description continue des grandes bases de données `~\cite{peyre2011numerical,umapprime}`{=latex}

`\vspace*{1cm}`{=latex}

::: columns
:::: {.column width=35%}
`\begin{center}`{=latex}
![](images/6n-graf.pdf){height=3cm}

 \
**Graphe** simple.

`\end{center}`{=latex}
::::
:::: {.column width=30%}
`\begin{center}`{=latex}
![](images/knn_graph.png){height=3cm}

 \
**Surface** sous-jacente.

`\end{center}`{=latex}
::::
:::: {.column width=35%}
`\begin{center}`{=latex}
![](images/primes_umap_8e6.png){height=3cm}

 \
**Visualisation** avec UMAP.

`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}

 \
Le $\BR{langage du continu}$ s'est invité en analyse de **données** : \
gradient, densité, variété, fonction test...

`\end{center}`{=latex}


## Une longue histoire en physique `~\cite{solar_system,ideal_gas,nabizadeh2022covector}`{=latex}

`\vspace*{.5cm}`{=latex}

::: columns
:::: {.column width=35%}
`\begin{center}`{=latex}
![](images/solar_system.png){height=3.5cm}

 \
Le système **solaire**.

`\end{center}`{=latex}
::::
:::: {.column width=40%}
`\begin{center}`{=latex}
![](images/ideal_gas.png){height=3.5cm}

 \
Le modèle des **gaz parfaits**.

`\end{center}`{=latex}
::::
:::: {.column width=25%}
`\begin{center}`{=latex}
![](images/fluid_simulation.png){height=3.5cm}

 \
Simulation **fluide**.

`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}

 \
Recherche en **physique** $~~\Longleftrightarrow~~$ **Supercalculateurs à Haute Performance** \
Accès restreint aux $\BR{centres institutionnels}$.

`\end{center}`{=latex}



## Une histoire récente dans l'industrie du cinéma et du jeu vidéo

`\vspace*{.5cm}`{=latex}

::: columns
:::: {.column width=33%}
`\begin{center}`{=latex}
![](images/FF.png){height=3.5cm}

 \
FFVII sur la PS1 -- 1997.

`\end{center}`{=latex}
::::
:::: {.column width=33%}
`\begin{center}`{=latex}
![](images/FF_remaster.jpg){height=3.5cm}

 \
FFVII sur la PS4 -- 2020.

`\end{center}`{=latex}
::::
:::: {.column width=33%}
`\begin{center}`{=latex}
![](images/jensen_huang.jpg){height=3.5cm}

 \
Jensen Huang -- 2022.

`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}

 \
Recherche en **informatique graphique** $~~\Longleftrightarrow~~$ **Graphics Processing Units** \
$\BR{Accessible}$ à tout labo de recherche : impact révolutionnaire.

`\end{center}`{=latex}


## Le matériel est au cœur de la "révolution de l'IA"

Les statistiques et l'apprentissage machine sont étudiés depuis des **décennies**. \
**Percée** en 2010-15 : utiliser des $\BR{PlayStations}$ pour faire de la $\BR{science}$ est devenu **facile**.

::: columns
:::: {.column width=70%}

 \
 \
Effort de recherche à tous les niveaux vers:

- Un **matériel** toujours plus puissant.
- Des **bibliothèques** toujours plus souples.
- Des **modèles** toujours plus pertinents.

 \
 \
Résultats **spectaculaires** obtenus dans quelques domaines \
$\Longrightarrow~~$ grands $\BR{investissements}$ publics et privés.

::::
:::: {.column width=30%}
`\begin{center}`{=latex}

![](images/ampere.jpg){height=4cm}

 \
**7,000 cœurs** sur un GPU.

`\end{center}`{=latex}
::::
:::


## Exemple : la bibliothèque KeOps `\texttt{~~www.kernel-operations.io}`{=latex}

`\begin{center}`{=latex}

![](images/keops.pdf){height=7cm}

`\end{center}`{=latex}


# Contexte humain

## HeKA : une équipe à l'interface de plusieurs mondes

`\begin{center}`{=latex}

![](images/HeKA.pdf){height=7cm}

`\end{center}`{=latex}

## Mission : mettre en valeur les entrepôts de données publiques

Nos sources principales :

- Dossiers patients des Hôpitaux Pompidou et Necker.
- Banque Nationale de Données **Maladies Rares**. 
- Données de l'$\BR{assurance maladie}$ -- décret R 1461-12 du 29 juin 2021.

`\begin{center}`{=latex}

 \
Soutien fort des tutelles pour \
la recherche **méthodologique** $\BR{et}$ la **"simple" application** aux données. \
 \
$\Longrightarrow~~$ Modèle de recherche $\BR{``translationnelle''}$ qui a fait ses preuves \
au Royaume-Uni, en croissance à Inria.

`\end{center}`{=latex}


## Différences de statut

À **Inria** -- beaucoup de **liberté** :

- Titularisation à $\sim$ 30 ans.
- Recherche à temps plein, en télétravail.
- Soutien à des projets construits sur 5 ans.
- Équipes de **support** dédiées, compétentes et bienveillantes.

 \
À l'**hôpital** -- une forte **pression** :

- Titularisation à $\sim$ 40 ans.
- $\BR{Soin + Enseignement + Recherche}$, **de jour comme de nuit.**
- *Publish or perish* assumé.
- Une $\BR{connexion internet stable}$ n'est **même pas** garantie !


## Différences de culture

Qu'est-ce qu'une $\BR{vérité scientifique}$ ?

- En maths : une **démonstration** formelle.
- En info : un logiciel bien **testé**.
- En médecine : un $\BR{consensus d'experts}$.


`\begin{center}`{=latex}

 \
En médecine et en biologie, le **"prestige de la paillasse"** est immense.

Les **analystes** sont souvent perçus comme des **"planqués"** ou des **subalternes**.

Faire $\BR{évoluer les mentalités}$ est un défi pour notre domaine.

`\end{center}`{=latex}


## Prendre ces facteurs en compte est essentiel pour percer

Stratégie de **long terme**, permise par Inria :

1. **Comprendre** le consensus existant, \
   longues discussions avec les médecins. \
   \

2. **Introduire** progressivement des outils modernes (GPUs...), \
   parfaite $\BR{rétro-compatibilité}$ avec les méthodes standards. \
   \

3. Utiliser l'**expérience** et la **crédibilité** acquises \
   pour introduire de **nouvelles méthodes**, lorsque c'est $\BR{nécessaire}$.


# Retour d'expérience en pharmaco-vigilance

## L'analyse de survie : un problème de classification sur les séries temporelles


`\begin{center}`{=latex}

![](images/survival.png){height=4.5cm}

`\end{center}`{=latex}

**Problème fondamental** pour :

- **Les usines** : quelle pièce sera la prochaine à casser ?
- **Les commerces** : quel client sera le premier à ne plus revenir ?
- **Les médecins** : quel patient sera le prochain à développer un cancer ?


## L'analyse de survie : en pratique

**Modèle standard** : les risques proportionnels de Cox (1972). \
$\qquad$ Descripteurs qui dépendent du temps : Weighted Cumulated Exposures (WCE), ...

 \
**Implémentation** : paquets $~\texttt{survival}~$ et $~\texttt{WCE}~$ pour R -- 10M+ téléchargements.

Excellent packaging, mais sans support des cartes graphiques :

- Acceptable pour des essais cliniques (1k--10k patients).
- Prohibitivement **lent** pour des études à grande échelle.

 \
$\BR{Projet Epi-Phare -- 150k€}$ : passer à l'échelle de l'assurance maladie. \
$\qquad$ **20 ans** de "tickets de caisses" de $\BR{cartes vitales}$, pour **70M+ de français**.


## Étape 1 : implémentation sur cartes graphiques

$\BR{Similarité}$ frappante entre modèles de survie et d'apprentissage :

- Modèle de **Cox** = régression **logistique** sur un **graphe** (1 nœud = 1 patient).
- Weighted Cumulative Exposures = **kernel** features.

J'ai implémenté un **solveur GPU rapide** pour ces méthodes. \
Alexis Van Straaten l'a empaqueté comme une **bibliothèque R**.

$\BR{survivalGPU}$ (pour R et Python) produit $\BR{exactement}$ la même sortie \
que les paquets standards **survival** et **WCE**, mais va $\BR{1,000 fois plus vite}$.

Deux principales conséquences :

- **Passage à l'échelle** : travailler avec des **millions de patients** en quelques minutes.
- **Bootstrap et permutations** : répéter la même expérience 1,000 fois \
  $\qquad$ pour estimer des intervalles de confiance.



## Étape 2 : obtenir l'accès aux données de l'assurance maladie (SNDS)

- **Inria** a reçu l'aval des autorités, par décret, en juin 2021.
- Inria a payé pour **ma formation d'une semaine** en Mai 2022 -- merci !

 \
$\BR{Problème :}$ le cloud $\texttt{Ameli.fr}$ n'est **pas pensé pour des méthodes originales**.

Configuration matérielle obsolète, avec seulement trois logiciels :

- Microsoft **Excel**.
- SAS (un système de requêtes **SQL**).
- **R** avec une collection **figée** de paquets standards.

 \
$\BR{Il nous faut absolument accéder à une machine \textbf{moderne} (GPU + Python + R)},$ \
répondant aux consignes de **sécurité** documentées par l'assurance maladie.


## Étape 3 : obtenir l'accès à un ordinateur sécurisé...

Nous bloquons sur ce point depuis **un an** :

- $\BR{Plan A :}$ notre requête au cloud de l'hôpital Pompidou a été rejetée.
  
- $\BR{Plan B :}$ nous avons acheté une **station de travail** moderne (5,600€)... \
  Avant de comprendre qu'il serait impossible de l'homologuer.

- $\BR{Plan C :}$ la DSI d'Inria travaille sur une solution de cloud sécurisé... \
  Mais ne pourra pas prioriser les **démarches spécifiques** à ces données.


 \
Situation très $\BR{confuse}$ autour des clouds homologués :

- Les **anciennes procédures** ont été dépréciées.
- Les **nouveaux guichets** comme le Health Data Hub \
  ne soutiennent que quelques **projets pilotes**.


## On y est presque...


`\vspace*{.5cm}`{=latex}

`\begin{center}`{=latex}

![](images/pipeline.png){height=4cm}

`\end{center}`{=latex}

Le $\BR{travail accompli}$ sur la dernière décennie est **considérable**.

Mais la question de l'**infrastructure** numérique est un $\BR{angle mort}$ majeur.

L'information circule mal :

- Multiplication des procédures, **illisibles**.
- Les **directions** ne sont généralement pas conscientes du $\BR{blocage sur le terrain}$.


## Conclusion

L'**hôpital** est une terre de contraste :

- Matériel de **science-fiction** en radiologie interventionnelle.
- "Le service n'a **pas accès à ses mails** aujourd'hui."
- Des $\BR{médecins formidables}$, dans des conditions aberrantes.


 \
En tant que **chercheur Inria** :

- J'ai énormément appris au **contact des médecins, pharmaciens et statisticiens**.
- Je souhaite prioriser les projets $\BR{qui aident tous les français}$.


`\begin{center}`{=latex}

 \
Je suis $\BR{très optimiste}$ : plus qu'**un problème à régler** avant de pouvoir travailler.

`\end{center}`{=latex}



# References